--- //depot/projects/trustedbsd/mac/sys/kern/sysv_sem.c	2003/03/24 20:14:00
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/kern/sysv_sem.c	2003/06/20 08:44:14
@@ -9,6 +9,7 @@
  */
 
 #include "opt_sysvipc.h"
+#include "opt_mac.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -24,6 +25,10 @@
 #include <sys/sysctl.h>
 #include <sys/malloc.h>
 #include <sys/jail.h>
+#ifdef MAC
+#include <sys/_label.h>
+#include <sys/mac.h>
+#endif
 
 static MALLOC_DEFINE(M_SEM, "sem", "SVID compatible semaphores");
 
@@ -38,7 +43,7 @@
 static int semunload(void);
 static void semexit_myhook(void *arg, struct proc *p);
 static int sysctl_sema(SYSCTL_HANDLER_ARGS);
-static int semvalid(int semid, struct semid_ds *semaptr);
+static int semvalid(int semid, struct semid_kernel  *semakptr);
 
 #ifndef _SYS_SYSPROTO_H_
 struct __semctl_args;
@@ -62,12 +67,14 @@
 
 static struct mtx	sem_mtx;	/* semaphore global lock */
 static int	semtot = 0;
-static struct semid_ds *sema;	/* semaphore id pool */
+static struct semid_kernel  *sema;	/* semaphore id pool */
 static struct mtx *sema_mtx;	/* semaphore id pool mutexes*/
 static struct sem *sem;		/* semaphore pool */
 SLIST_HEAD(, sem_undo) semu_list;	/* list of active undo structures */
 static int	*semu;		/* undo structure pool */
 static eventhandler_tag semexit_tag;
+static int refcount; /* to ensure consistency during and after semunload */
+static struct mtx refcnt_mtx;	/* global mutex for refcount. */
 
 #define SEMUNDO_MTX		sem_mtx
 #define SEMUNDO_LOCK()		mtx_lock(&SEMUNDO_MTX);
@@ -188,15 +195,18 @@
 	TUNABLE_INT_FETCH("kern.ipc.semaem", &seminfo.semaem);
 
 	sem = malloc(sizeof(struct sem) * seminfo.semmns, M_SEM, M_WAITOK);
-	sema = malloc(sizeof(struct semid_ds) * seminfo.semmni, M_SEM,
+	sema = malloc(sizeof(struct semid_kernel ) * seminfo.semmni, M_SEM,
 	    M_WAITOK);
 	sema_mtx = malloc(sizeof(struct mtx) * seminfo.semmni, M_SEM,
 	    M_WAITOK | M_ZERO);
 	semu = malloc(seminfo.semmnu * seminfo.semusz, M_SEM, M_WAITOK);
 
 	for (i = 0; i < seminfo.semmni; i++) {
-		sema[i].sem_base = 0;
-		sema[i].sem_perm.mode = 0;
+		sema[i].u.sem_base = 0;
+		sema[i].u.sem_perm.mode = 0;
+#ifdef MAC
+		mac_init_ipc_sema(&sema[i]);
+#endif
 	}
 	for (i = 0; i < seminfo.semmni; i++)
 		mtx_init(&sema_mtx[i], "semid", NULL, MTX_DEF);
@@ -206,6 +216,16 @@
 	}
 	SLIST_INIT(&semu_list);
 	mtx_init(&sem_mtx, "sem", NULL, MTX_DEF);
+	refcount =0;
+	/* 
+	 * It is not permissible to pass the same mutex to mtx_init() multiple 
+	 * times without intervening calls to mtx_destroy().
+	 * Since we cannot destroy the refcnt_mtx during semunload, we check if the 
+	 * mtx_init has ever been called. If so, we dont need to do mtx_init as the 
+	 * mutex is already initialized.
+	 */
+	if ( mtx_initialized(&refcnt_mtx) == 0 )
+		mtx_init(&refcnt_mtx, "semrefcnt", NULL, MTX_DEF);
 	semexit_tag = EVENTHANDLER_REGISTER(process_exit, semexit_myhook, NULL,
 	    EVENTHANDLER_PRI_ANY);
 }
@@ -215,16 +235,37 @@
 {
 	int i;
 
-	if (semtot != 0)
+	/* 
+	 * Make sure that the semunload maintains the consistency of the sem and 
+	 * sema data structures. This assures that the unload doesn't take
+	 * place if any thread is in any of the code-paths (tinkering with the
+	 * data structures), and also that no thread can enter the code-paths once
+	 * the module is unloaded. 
+	 */
+	mtx_lock(&refcnt_mtx);
+	if ((refcount > 0) || (semtot != 0)) {
+		mtx_unlock(&refcnt_mtx);
 		return (EBUSY);
+	}
+	refcount= -1; /* Mark the module as being unloaded */
+	mtx_unlock(&refcnt_mtx);
 
 	EVENTHANDLER_DEREGISTER(process_exit, semexit_tag);
+#ifdef MAC
+	for (i = 0; i < seminfo.semmni; i++) 
+		mac_destroy_ipc_sema(&sema[i]);
+#endif 
 	free(sem, M_SEM);
 	free(sema, M_SEM);
 	free(semu, M_SEM);
 	for (i = 0; i < seminfo.semmni; i++)
 		mtx_destroy(&sema_mtx[i]);
 	mtx_destroy(&sem_mtx);
+	/* 
+	 * NOTE: We cannot destroy the refcnt_mtx as it is possible that some thread
+	 * might (attempt to) hold the mutex.
+	 */
+/* 	mtx_destroy(&refcnt_mtx); */
 	return (0);
 }
 
@@ -467,13 +508,13 @@
 }
 
 static int
-semvalid(semid, semaptr)
+semvalid(semid, semakptr)
 	int semid;
-	struct semid_ds *semaptr;
+	struct semid_kernel  *semakptr;
 {
 
-	return ((semaptr->sem_perm.mode & SEM_ALLOC) == 0 ||
-	    semaptr->sem_perm.seq != IPCID_TO_SEQ(semid) ? EINVAL : 0);
+	return ((semakptr->u.sem_perm.mode & SEM_ALLOC) == 0 ||
+	    semakptr->u.sem_perm.seq != IPCID_TO_SEQ(semid) ? EINVAL : 0);
 }
 
 /*
@@ -505,7 +546,7 @@
 	struct ucred *cred = td->td_ucred;
 	int i, rval, error;
 	struct semid_ds sbuf;
-	struct semid_ds *semaptr;
+	struct semid_kernel  *semakptr;
 	struct mtx *sema_mtxp;
 	u_short usval, count;
 
@@ -514,37 +555,68 @@
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
 
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++; /* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	array = NULL;
 
 	switch(cmd) {
 	case SEM_STAT:
-		if (semid < 0 || semid >= seminfo.semmni)
-			return (EINVAL);
+		if (semid < 0 || semid >= seminfo.semmni) {
+			error =  EINVAL;
+			goto done3;
+		}
 		if ((error = copyin(arg, &real_arg, sizeof(real_arg))) != 0)
-			return (error);
-		semaptr = &sema[semid];
+			goto done3;
+		semakptr = &sema[semid];
 		sema_mtxp = &sema_mtx[semid];
 		mtx_lock(sema_mtxp);
-		if ((semaptr->sem_perm.mode & SEM_ALLOC) == 0 ) {
+		if ((semakptr->u.sem_perm.mode & SEM_ALLOC) == 0 ) {
 			error = EINVAL;
 			goto done2;
 		}
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_R)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_R)))
 			goto done2;
+#ifdef MAC
+  	if(( error = mac_check_ipc_semctl(cred,semakptr,cmd) )) {
+  		DPRINTF(("MAC Framework:  mac_check_ipc_semctl access denied\n"));
+	  	goto done2;
+		}
+#endif
 		mtx_unlock(sema_mtxp);
-		error = copyout(semaptr, real_arg.buf, sizeof(struct semid_ds));
-		rval = IXSEQ_TO_IPCID(semid,semaptr->sem_perm);
+		error = copyout(&semakptr->u, real_arg.buf, sizeof(struct semid_ds));
+		rval = IXSEQ_TO_IPCID(semid,semakptr->u.sem_perm);
 		if (error == 0)
 			td->td_retval[0] = rval;
-		return (error);
+		goto done3;
 	}
 
 	semid = IPCID_TO_IX(semid);
-	if (semid < 0 || semid >= seminfo.semmni)
-		return (EINVAL);
+	if (semid < 0 || semid >= seminfo.semmni) {
+		error = EINVAL;
+		goto done3;
+	}
 
-	semaptr = &sema[semid];
+	semakptr = &sema[semid];
 	sema_mtxp = &sema_mtx[semid];
+#ifdef MAC
+  mtx_lock(sema_mtxp);
+	/* 
+	 * The MAC framework lets the policies decide what type of access
+	 * is permitted, based on the cmd.
+	 */
+  if(( error = mac_check_ipc_semctl(cred,semakptr,cmd) )) {
+  	DPRINTF(("MAC Framework:  mac_check_ipc_semctl access denied\n"));
+	  goto done2;
+	}
+	mtx_unlock(sema_mtxp);
+#endif
 		
 	error = 0;
 	rval = 0;
@@ -552,25 +624,29 @@
 	switch (cmd) {
 	case IPC_RMID:
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_M)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_M)))
 			goto done2;
-		semaptr->sem_perm.cuid = cred->cr_uid;
-		semaptr->sem_perm.uid = cred->cr_uid;
-		semtot -= semaptr->sem_nsems;
-		for (i = semaptr->sem_base - sem; i < semtot; i++)
-			sem[i] = sem[i + semaptr->sem_nsems];
+		semakptr->u.sem_perm.cuid = cred->cr_uid;
+		semakptr->u.sem_perm.uid = cred->cr_uid;
+		semtot -= semakptr->u.sem_nsems;
+		for (i = semakptr->u.sem_base - sem; i < semtot; i++)
+			sem[i] = sem[i + semakptr->u.sem_nsems];
 		for (i = 0; i < seminfo.semmni; i++) {
-			if ((sema[i].sem_perm.mode & SEM_ALLOC) &&
-			    sema[i].sem_base > semaptr->sem_base)
-				sema[i].sem_base -= semaptr->sem_nsems;
+			if ((sema[i].u.sem_perm.mode & SEM_ALLOC) &&
+			    sema[i].u.sem_base > semakptr->u.sem_base)
+				sema[i].u.sem_base -= semakptr->u.sem_nsems;
 		}
-		semaptr->sem_perm.mode = 0;
+		semakptr->u.sem_perm.mode = 0;
+#ifdef MAC
+		/* XXX: Reset the MAC label */
+		mac_cleanup_ipc_sema(semakptr);
+#endif
 		SEMUNDO_LOCK();
 		semundo_clear(semid, -1);
 		SEMUNDO_UNLOCK();
-		wakeup(semaptr);
+		wakeup(semakptr);
 		break;
 
 	case IPC_SET:
@@ -579,82 +655,82 @@
 		if ((error = copyin(real_arg.buf, &sbuf, sizeof(sbuf))) != 0)
 			goto done2;
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_M)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_M)))
 			goto done2;
-		semaptr->sem_perm.uid = sbuf.sem_perm.uid;
-		semaptr->sem_perm.gid = sbuf.sem_perm.gid;
-		semaptr->sem_perm.mode = (semaptr->sem_perm.mode & ~0777) |
+		semakptr->u.sem_perm.uid = sbuf.sem_perm.uid;
+		semakptr->u.sem_perm.gid = sbuf.sem_perm.gid;
+		semakptr->u.sem_perm.mode = (semakptr->u.sem_perm.mode & ~0777) |
 		    (sbuf.sem_perm.mode & 0777);
-		semaptr->sem_ctime = time_second;
+		semakptr->u.sem_ctime = time_second;
 		break;
 
 	case IPC_STAT:
 		if ((error = copyin(arg, &real_arg, sizeof(real_arg))) != 0)
 			goto done2;
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_R)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_R)))
 			goto done2;
-		sbuf = *semaptr;
+		sbuf = semakptr->u;
 		mtx_unlock(sema_mtxp);
-		error = copyout(semaptr, real_arg.buf,
+		error = copyout(&semakptr->u, real_arg.buf,
 				sizeof(struct semid_ds));
 		break;
 
 	case GETNCNT:
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_R)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_R)))
 			goto done2;
-		if (semnum < 0 || semnum >= semaptr->sem_nsems) {
+		if (semnum < 0 || semnum >= semakptr->u.sem_nsems) {
 			error = EINVAL;
 			goto done2;
 		}
-		rval = semaptr->sem_base[semnum].semncnt;
+		rval = semakptr->u.sem_base[semnum].semncnt;
 		break;
 
 	case GETPID:
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_R)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_R)))
 			goto done2;
-		if (semnum < 0 || semnum >= semaptr->sem_nsems) {
+		if (semnum < 0 || semnum >= semakptr->u.sem_nsems) {
 			error = EINVAL;
 			goto done2;
 		}
-		rval = semaptr->sem_base[semnum].sempid;
+		rval = semakptr->u.sem_base[semnum].sempid;
 		break;
 
 	case GETVAL:
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_R)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_R)))
 			goto done2;
-		if (semnum < 0 || semnum >= semaptr->sem_nsems) {
+		if (semnum < 0 || semnum >= semakptr->u.sem_nsems) {
 			error = EINVAL;
 			goto done2;
 		}
-		rval = semaptr->sem_base[semnum].semval;
+		rval = semakptr->u.sem_base[semnum].semval;
 		break;
 
 	case GETALL:
 		if ((error = copyin(arg, &real_arg, sizeof(real_arg))) != 0)
 			goto done2;
-		array = malloc(sizeof(*array) * semaptr->sem_nsems, M_TEMP,
+		array = malloc(sizeof(*array) * semakptr->u.sem_nsems, M_TEMP,
 		    M_WAITOK);
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_R)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_R)))
 			goto done2;
-		for (i = 0; i < semaptr->sem_nsems; i++)
-			array[i] = semaptr->sem_base[i].semval;
+		for (i = 0; i < semakptr->u.sem_nsems; i++)
+			array[i] = semakptr->u.sem_base[i].semval;
 		mtx_unlock(sema_mtxp);
 		error = copyout(array, real_arg.array,
 		    i * sizeof(real_arg.array[0]));
@@ -662,26 +738,26 @@
 
 	case GETZCNT:
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_R)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_R)))
 			goto done2;
-		if (semnum < 0 || semnum >= semaptr->sem_nsems) {
+		if (semnum < 0 || semnum >= semakptr->u.sem_nsems) {
 			error = EINVAL;
 			goto done2;
 		}
-		rval = semaptr->sem_base[semnum].semzcnt;
+		rval = semakptr->u.sem_base[semnum].semzcnt;
 		break;
 
 	case SETVAL:
 		if ((error = copyin(arg, &real_arg, sizeof(real_arg))) != 0)
 			goto done2;
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_W)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_W)))
 			goto done2;
-		if (semnum < 0 || semnum >= semaptr->sem_nsems) {
+		if (semnum < 0 || semnum >= semakptr->u.sem_nsems) {
 			error = EINVAL;
 			goto done2;
 		}
@@ -689,19 +765,19 @@
 			error = ERANGE;
 			goto done2;
 		}
-		semaptr->sem_base[semnum].semval = real_arg.val;
+		semakptr->u.sem_base[semnum].semval = real_arg.val;
 		SEMUNDO_LOCK();
 		semundo_clear(semid, semnum);
 		SEMUNDO_UNLOCK();
-		wakeup(semaptr);
+		wakeup(semakptr);
 		break;
 
 	case SETALL:
 		mtx_lock(sema_mtxp);
 raced:
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
-		count = semaptr->sem_nsems;
+		count = semakptr->u.sem_nsems;
 		mtx_unlock(sema_mtxp);
 		if ((error = copyin(arg, &real_arg, sizeof(real_arg))) != 0)
 			goto done2;
@@ -710,28 +786,28 @@
 		if (error)
 			break;
 		mtx_lock(sema_mtxp);
-		if ((error = semvalid(uap->semid, semaptr)) != 0)
+		if ((error = semvalid(uap->semid, semakptr)) != 0)
 			goto done2;
 		/* we could have raced? */
-		if (count != semaptr->sem_nsems) {
+		if (count != semakptr->u.sem_nsems) {
 			free(array, M_TEMP);
 			array = NULL;
 			goto raced;
 		}
-		if ((error = ipcperm(td, &semaptr->sem_perm, IPC_W)))
+		if ((error = ipcperm(td, &semakptr->u.sem_perm, IPC_W)))
 			goto done2;
-		for (i = 0; i < semaptr->sem_nsems; i++) {
+		for (i = 0; i < semakptr->u.sem_nsems; i++) {
 			usval = array[i];
 			if (usval > seminfo.semvmx) {
 				error = ERANGE;
 				break;
 			}
-			semaptr->sem_base[i].semval = usval;
+			semakptr->u.sem_base[i].semval = usval;
 		}
 		SEMUNDO_LOCK();
 		semundo_clear(semid, -1);
 		SEMUNDO_UNLOCK();
-		wakeup(semaptr);
+		wakeup(semakptr);
 		break;
 
 	default:
@@ -746,6 +822,10 @@
 		mtx_unlock(sema_mtxp);
 	if (array != NULL)
 		free(array, M_TEMP);
+done3:
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return(error);
 }
 
@@ -775,20 +855,29 @@
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
 
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++; /* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	mtx_lock(&Giant);
 	if (key != IPC_PRIVATE) {
 		for (semid = 0; semid < seminfo.semmni; semid++) {
-			if ((sema[semid].sem_perm.mode & SEM_ALLOC) &&
-			    sema[semid].sem_perm.key == key)
+			if ((sema[semid].u.sem_perm.mode & SEM_ALLOC) &&
+			    sema[semid].u.sem_perm.key == key)
 				break;
 		}
 		if (semid < seminfo.semmni) {
 			DPRINTF(("found public key\n"));
-			if ((error = ipcperm(td, &sema[semid].sem_perm,
+			if ((error = ipcperm(td, &sema[semid].u.sem_perm,
 			    semflg & 0700))) {
 				goto done2;
 			}
-			if (nsems > 0 && sema[semid].sem_nsems < nsems) {
+			if (nsems > 0 && sema[semid].u.sem_nsems < nsems) {
 				DPRINTF(("too small\n"));
 				error = EINVAL;
 				goto done2;
@@ -798,11 +887,17 @@
 				error = EEXIST;
 				goto done2;
 			}
+#ifdef MAC 
+		  if(( error = mac_check_ipc_semget(cred,&sema[semid]) )) {
+		  	DPRINTF(("MAC Framework:  mac_check_ipc_semget access denied\n"));
+			  goto done2;
+			}
+#endif
 			goto found;
 		}
 	}
 
-	DPRINTF(("need to allocate the semid_ds\n"));
+	DPRINTF(("need to allocate the semid_kernel \n"));
 	if (key == IPC_PRIVATE || (semflg & IPC_CREAT)) {
 		if (nsems <= 0 || nsems > seminfo.semmsl) {
 			DPRINTF(("nsems out of range (0<%d<=%d)\n", nsems,
@@ -818,31 +913,34 @@
 			goto done2;
 		}
 		for (semid = 0; semid < seminfo.semmni; semid++) {
-			if ((sema[semid].sem_perm.mode & SEM_ALLOC) == 0)
+			if ((sema[semid].u.sem_perm.mode & SEM_ALLOC) == 0)
 				break;
 		}
 		if (semid == seminfo.semmni) {
-			DPRINTF(("no more semid_ds's available\n"));
+			DPRINTF(("no more semid_kernel 's available\n"));
 			error = ENOSPC;
 			goto done2;
 		}
 		DPRINTF(("semid %d is available\n", semid));
-		sema[semid].sem_perm.key = key;
-		sema[semid].sem_perm.cuid = cred->cr_uid;
-		sema[semid].sem_perm.uid = cred->cr_uid;
-		sema[semid].sem_perm.cgid = cred->cr_gid;
-		sema[semid].sem_perm.gid = cred->cr_gid;
-		sema[semid].sem_perm.mode = (semflg & 0777) | SEM_ALLOC;
-		sema[semid].sem_perm.seq =
-		    (sema[semid].sem_perm.seq + 1) & 0x7fff;
-		sema[semid].sem_nsems = nsems;
-		sema[semid].sem_otime = 0;
-		sema[semid].sem_ctime = time_second;
-		sema[semid].sem_base = &sem[semtot];
+		sema[semid].u.sem_perm.key = key;
+		sema[semid].u.sem_perm.cuid = cred->cr_uid;
+		sema[semid].u.sem_perm.uid = cred->cr_uid;
+		sema[semid].u.sem_perm.cgid = cred->cr_gid;
+		sema[semid].u.sem_perm.gid = cred->cr_gid;
+		sema[semid].u.sem_perm.mode = (semflg & 0777) | SEM_ALLOC;
+		sema[semid].u.sem_perm.seq =
+		    (sema[semid].u.sem_perm.seq + 1) & 0x7fff;
+		sema[semid].u.sem_nsems = nsems;
+		sema[semid].u.sem_otime = 0;
+		sema[semid].u.sem_ctime = time_second;
+		sema[semid].u.sem_base = &sem[semtot];
 		semtot += nsems;
-		bzero(sema[semid].sem_base,
-		    sizeof(sema[semid].sem_base[0])*nsems);
-		DPRINTF(("sembase = 0x%x, next = 0x%x\n", sema[semid].sem_base,
+		bzero(sema[semid].u.sem_base,
+		    sizeof(sema[semid].u.sem_base[0])*nsems);
+#ifdef MAC
+		mac_create_ipc_sema(cred, &sema[semid]);
+#endif
+		DPRINTF(("sembase = 0x%x, next = 0x%x\n", sema[semid].u.sem_base,
 		    &sem[semtot]));
 	} else {
 		DPRINTF(("didn't find it and wasn't asked to create it\n"));
@@ -851,9 +949,12 @@
 	}
 
 found:
-	td->td_retval[0] = IXSEQ_TO_IPCID(semid, sema[semid].sem_perm);
+	td->td_retval[0] = IXSEQ_TO_IPCID(semid, sema[semid].u.sem_perm);
 done2:
 	mtx_unlock(&Giant);
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 }
 
@@ -876,7 +977,7 @@
 	int semid = uap->semid;
 	size_t nsops = uap->nsops;
 	struct sembuf *sops;
-	struct semid_ds *semaptr;
+	struct semid_kernel  *semakptr;
 	struct sembuf *sopptr = 0;
 	struct sem *semptr = 0;
 	struct sem_undo *suptr;
@@ -890,33 +991,45 @@
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
 
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++; /* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	semid = IPCID_TO_IX(semid);	/* Convert back to zero origin */
 
-	if (semid < 0 || semid >= seminfo.semmni)
-		return (EINVAL);
+	if (semid < 0 || semid >= seminfo.semmni) {
+		error = EINVAL;
+		goto done3;
+	}
 
 	/* Allocate memory for sem_ops */
 	if (nsops > seminfo.semopm) {
 		DPRINTF(("too many sops (max=%d, nsops=%d)\n", seminfo.semopm,
 		    nsops));
-		return (E2BIG);
+		error = E2BIG;
+		goto done3;
 	}
 	sops = malloc(nsops * sizeof(sops[0]), M_SEM, M_WAITOK);
 	if ((error = copyin(uap->sops, sops, nsops * sizeof(sops[0]))) != 0) {
 		DPRINTF(("error = %d from copyin(%08x, %08x, %d)\n", error,
 		    uap->sops, sops, nsops * sizeof(sops[0])));
 		free(sops, M_SEM);
-		return (error);
+		goto done3;
 	}
 
-	semaptr = &sema[semid];
+	semakptr = &sema[semid];
 	sema_mtxp = &sema_mtx[semid];
 	mtx_lock(sema_mtxp);
-	if ((semaptr->sem_perm.mode & SEM_ALLOC) == 0) {
+	if ((semakptr->u.sem_perm.mode & SEM_ALLOC) == 0) {
 		error = EINVAL;
 		goto done2;
 	}
-	if (semaptr->sem_perm.seq != IPCID_TO_SEQ(uap->semid)) {
+	if (semakptr->u.sem_perm.seq != IPCID_TO_SEQ(uap->semid)) {
 		error = EINVAL;
 		goto done2;
 	}
@@ -929,7 +1042,7 @@
 	do_undos = 0;
 	for (i = 0; i < nsops; i++) {
 		sopptr = &sops[i];
-		if (sopptr->sem_num >= semaptr->sem_nsems) {
+		if (sopptr->sem_num >= semakptr->u.sem_nsems) {
 			error = EFBIG;
 			goto done2;
 		}
@@ -938,10 +1051,20 @@
 		j |= (sopptr->sem_op == 0) ? SEM_R : SEM_A;
 	}
 
-	if ((error = ipcperm(td, &semaptr->sem_perm, j))) {
+	if ((error = ipcperm(td, &semakptr->u.sem_perm, j))) {
 		DPRINTF(("error = %d from ipaccess\n", error));
 		goto done2;
 	}
+#ifdef MAC
+	/* 
+	 * The MAC hook checks whether the thread has read ( and possibly write)
+	 * permissions to the semaphore array based on the sopptr->sem_op value.
+	 */
+	if ((error = mac_check_ipc_semop(td->td_ucred, semakptr, j))) {
+		DPRINTF(("MAC Framework:  mac_check_ipc_semop access denied\n"));
+		goto done2;
+	}
+#endif
 
 	/*
 	 * Loop trying to satisfy the vector of requests.
@@ -958,12 +1081,12 @@
 
 		for (i = 0; i < nsops; i++) {
 			sopptr = &sops[i];
-			semptr = &semaptr->sem_base[sopptr->sem_num];
+			semptr = &semakptr->u.sem_base[sopptr->sem_num];
 
 			DPRINTF((
-			    "semop:  semaptr=%x, sem_base=%x, "
+			    "semop:  semakptr=%x, sem_base=%x, "
 			    "semptr=%x, sem[%d]=%d : op=%d, flag=%s\n",
-			    semaptr, semaptr->sem_base, semptr,
+			    semakptr, semakptr->u.sem_base, semptr,
 			    sopptr->sem_num, semptr->semval, sopptr->sem_op,
 			    (sopptr->sem_flg & IPC_NOWAIT) ?
 			    "nowait" : "wait"));
@@ -1005,7 +1128,7 @@
 		 */
 		DPRINTF(("semop:  rollback 0 through %d\n", i-1));
 		for (j = 0; j < i; j++)
-			semaptr->sem_base[sops[j].sem_num].semval -=
+			semakptr->u.sem_base[sops[j].sem_num].semval -=
 			    sops[j].sem_op;
 
 		/* If we detected an error, return it */
@@ -1027,7 +1150,7 @@
 			semptr->semncnt++;
 
 		DPRINTF(("semop:  good night!\n"));
-		error = msleep(semaptr, sema_mtxp, (PZERO - 4) | PCATCH,
+		error = msleep(semakptr, sema_mtxp, (PZERO - 4) | PCATCH,
 		    "semwait", 0);
 		DPRINTF(("semop:  good morning (error=%d)!\n", error));
 
@@ -1040,8 +1163,8 @@
 		/*
 		 * Make sure that the semaphore still exists
 		 */
-		if ((semaptr->sem_perm.mode & SEM_ALLOC) == 0 ||
-		    semaptr->sem_perm.seq != IPCID_TO_SEQ(uap->semid)) {
+		if ((semakptr->u.sem_perm.mode & SEM_ALLOC) == 0 ||
+		    semakptr->u.sem_perm.seq != IPCID_TO_SEQ(uap->semid)) {
 			error = EIDRM;
 			goto done2;
 		}
@@ -1102,7 +1225,7 @@
 			}
 
 			for (j = 0; j < nsops; j++)
-				semaptr->sem_base[sops[j].sem_num].semval -=
+				semakptr->u.sem_base[sops[j].sem_num].semval -=
 				    sops[j].sem_op;
 
 			DPRINTF(("error = %d from semundo_adjust\n", error));
@@ -1115,10 +1238,10 @@
 	/* We're definitely done - set the sempid's and time */
 	for (i = 0; i < nsops; i++) {
 		sopptr = &sops[i];
-		semptr = &semaptr->sem_base[sopptr->sem_num];
+		semptr = &semakptr->u.sem_base[sopptr->sem_num];
 		semptr->sempid = td->td_proc->p_pid;
 	}
-	semaptr->sem_otime = time_second;
+	semakptr->u.sem_otime = time_second;
 
 	/*
 	 * Do a wakeup if any semaphore was up'd whilst something was
@@ -1126,7 +1249,7 @@
 	 */
 	if (do_wakeup) {
 		DPRINTF(("semop:  doing wakeup\n"));
-		wakeup(semaptr);
+		wakeup(semakptr);
 		DPRINTF(("semop:  back from wakeup\n"));
 	}
 	DPRINTF(("semop:  done\n"));
@@ -1134,6 +1257,10 @@
 done2:
 	mtx_unlock(sema_mtxp);
 	free(sops, M_SEM);
+done3:
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 }
 
@@ -1176,16 +1303,16 @@
 			int semid = suptr->un_ent[ix].un_id;
 			int semnum = suptr->un_ent[ix].un_num;
 			int adjval = suptr->un_ent[ix].un_adjval;
-			struct semid_ds *semaptr;
+			struct semid_kernel  *semakptr;
 			struct mtx *sema_mtxp;
 
-			semaptr = &sema[semid];
+			semakptr = &sema[semid];
 			sema_mtxp = &sema_mtx[semid];
 			mtx_lock(sema_mtxp);
 			SEMUNDO_LOCK();
-			if ((semaptr->sem_perm.mode & SEM_ALLOC) == 0)
+			if ((semakptr->u.sem_perm.mode & SEM_ALLOC) == 0)
 				panic("semexit - semid not allocated");
-			if (semnum >= semaptr->sem_nsems)
+			if (semnum >= semakptr->u.sem_nsems)
 				panic("semexit - semnum out of range");
 
 			DPRINTF((
@@ -1193,18 +1320,18 @@
 			    suptr->un_proc, suptr->un_ent[ix].un_id,
 			    suptr->un_ent[ix].un_num,
 			    suptr->un_ent[ix].un_adjval,
-			    semaptr->sem_base[semnum].semval));
+			    semakptr->u.sem_base[semnum].semval));
 
 			if (adjval < 0) {
-				if (semaptr->sem_base[semnum].semval < -adjval)
-					semaptr->sem_base[semnum].semval = 0;
+				if (semakptr->u.sem_base[semnum].semval < -adjval)
+					semakptr->u.sem_base[semnum].semval = 0;
 				else
-					semaptr->sem_base[semnum].semval +=
+					semakptr->u.sem_base[semnum].semval +=
 					    adjval;
 			} else
-				semaptr->sem_base[semnum].semval += adjval;
+				semakptr->u.sem_base[semnum].semval += adjval;
 
-			wakeup(semaptr);
+			wakeup(semakptr);
 			DPRINTF(("semexit:  back from wakeup\n"));
 			mtx_unlock(sema_mtxp);
 			SEMUNDO_UNLOCK();
